#include "StdAfx.h"
#include "Filter.h"

Filter::Filter(void)
{
}

//-------------------------------------------------------------------------------------------
//y֐@zFFilter::Color2Gray1
//yTvzFJ[摜mNO[֕ϊ
//y@@zFpSrc		= ͉摜i24BitJ[j(In)
//            FpDst		= o͉摜i8BitmNj(In)
//            FWidth		= 摜̕(In)
//            FHeight		= 摜̍(In)
//y߂l@zFȂ
//yl@@zFMono = (R + G + B) / 3
//-------------------------------------------------------------------------------------------
void Filter::Color2Mono1(unsigned char* pSrc, unsigned char* pDst, int Width, int Height){
	int i, j;
	int SrcStride, DstStride;

	//͉摜iJ[摜j̃̕
	SrcStride = ((Width * 24 + 31) / 32) * 4;
	//o͉摜imN摜j̃̕
	DstStride = ((Width * 8 + 31) / 32) * 4;

	for (j = 0; j < Height; j++){
		for (i = 0; i < Width; i++){
			pDst[i + j * DstStride] = (					   //Mono
						 pSrc[i * 3 +     j * SrcStride]   //B
					   + pSrc[i * 3 + 1 + j * SrcStride]   //G
					   + pSrc[i * 3 + 2 + j * SrcStride]   //R
					   ) / 3;
		}
	}
}

//-------------------------------------------------------------------------------------------
//y֐@zFFilter::Color2Gray2
//yTvzFJ[摜mNO[֕ϊ
//y@@zFpSrc		= ͉摜i24BitJ[j(In)
//            FpDst		= o͉摜i8BitmNj(In)
//            FWidth		= 摜̕(In)
//            FHeight		= 摜̍(In)
//y߂l@zFȂ
//yl@@zFMono = 0.299 * R + 0.587 * G + 0.114 * B
//            FYUVϊ̂xƓ
//-------------------------------------------------------------------------------------------
void Filter::Color2Mono2(unsigned char* pSrc, unsigned char* pDst, int Width, int Height){
	int i, j;
	int SrcStride, DstStride;
	unsigned char RLut[256], GLut[256], BLut[256];

	//͉摜iJ[摜j̃̕
	SrcStride = ((Width * 24 + 31) / 32) * 4;
	//o͉摜imN摜j̃̕
	DstStride = ((Width * 8 + 31) / 32) * 4;

	//qfaꂼLUT쐬
	for (i = 0; i < 256; i++){
		RLut[i] = (unsigned char)System::Math::Round(0.299 * i);
		GLut[i] = (unsigned char)System::Math::Round(0.587 * i);
		BLut[i] = (unsigned char)System::Math::Round(0.114 * i);
	}
	
	for (j = 0; j < Height; j++){
		for (i = 0; i < Width; i++){
			pDst[i + j * DstStride] = 							//Mono
						 BLut[pSrc[i * 3 +     j * SrcStride]]	//B
					   + GLut[pSrc[i * 3 + 1 + j * SrcStride]]	//G
					   + RLut[pSrc[i * 3 + 2 + j * SrcStride]]	//R
					   ;
		}
	}
}

//-------------------------------------------------------------------------------------------
//y֐@zFFilter::Binarization
//yTvzFl
//y@@zFpSrc		= ͉摜i8BitmNj(In)
//            FpDst		= o͉摜i8BitmNj(In)
//            FWidth		= 摜̕(In)
//            FHeight		= 摜̍(In)
//            FThreshold	= l(In)
//y߂l@zFȂ
//yl@@zF
//-------------------------------------------------------------------------------------------
void Filter::Binarization(unsigned char* pSrc, unsigned char* pDst, int Width, int Height, int Threshold){
	int i;
	int BufSize;
	unsigned char LUT[256] = {0};
	
	//摜Ŝ̃TCY
	BufSize = (Width + 3) / 4 * 4 * Height;

	//lbNAbve[u̍쐬
	for ( i = Threshold; i < 256; i++)
		LUT[i] = 255;

	//l
	for ( i = 0; i < BufSize; i++)
		pDst[i] =  LUT[ pSrc[i] ];

}


